
#pragma once

#ifndef __RYDOT_TEXTURE_FILE_LOADER_H__
#define __RYDOT_TEXTURE_FILE_LOADER_H__

#include <stdio.h>
#include <glex/texture.h>
#include <string>

namespace Rydot
{

class ITextureFileLoader
{
public:
	ITextureFileLoader(){}
	virtual ~ITextureFileLoader(){}
protected:
	virtual int Load(Texture &tex,std::string fn)=0;
	
	//fXgN^ŎIɕt@C
	class file
	{
	protected:
		FILE *fp;
	public:
		file(std::string fn,std::string attr)
		{fp=::fopen(fn.c_str(),attr.c_str());}
		~file()
		{if(fp){::fclose(fp);fp=0;}}
		size_t read(void *buffer, size_t size, size_t count)
		{
			if(fp)
				return ::fread(buffer,size,count,fp);
			return 0;
		}
		int seek(int offset,int origin)
		{
			if(fp)
				return ::fseek(fp,offset,origin);
			return -1;
		}
		FILE *get(){return fp;}
	};
};

}//end of namespace Rydot

#endif

