
#pragma once
#ifndef __SINGLETON_H__
#define __SINGLETON_H__

namespace Rydot
{

//T^̃IuWFNgAvP[Vɍő1~ƂɎgB
//ŏɃANZXƂT^̃IuWFNgAAvP[VIɉ̂B
//rŉ̂łȂ̂ŁAɂłIuWFNgƂƍ邩B
//TNXsingletonԂĎg悤ɂ΂B
//	singleton<xxx> a;
//	singleton<xxx> b;
//ƂĂ&a.instance()==&b.instance()ɂȂB
//֗Ȃ̂sւȂ̂...

template <class T>
struct singleton
{
	T &instance()
	{
		static T inst;
		return inst;
	}
	
	//|C^ۂ
	T &operator*(){return instance();}
	T *operator->(){return &instance();}
};

template <class T>
struct const_singleton
{
	const T &instance()const
	{
		static const T inst;
		return inst;
	}

	//|C^ۂ
	const T &operator*()const{return instance();}
	const T *operator->()const{return &instance();}
};

}//end of namespace Rydot

#endif
