
#ifndef __COLOR_H__
#define __COLOR_H__

#include <windows.h>

union UColor
{
	DWORD dwColor;
	struct
	{
		BYTE byBlue;
		BYTE byGreen;
		BYTE byRed;
		BYTE byAlpha;
	};
	struct
	{
		BYTE byCyan;
		BYTE byYellow;
		BYTE byMazenda;
		BYTE byAlpha;
	};
};



class CColor
{
public:
	UColor unColor;
public:
	BlendARGB(CColor *pOther,float fAlpha);
	BlendRGB(CColor *pOther,float fAlpha);
	BlendCYM(CColor *pOther,float fAlpha);
	UColor GetACYM();
	SetACYM(UColor ACYM);
	AddCYM(CColor *pOther,float fAlpha);
};

#endif