
#pragma once

#ifndef __MESSAGETHREAD_H__
#define __MESSAGETHREAD_H__

#include <cthread.h>
#include <messagequeue.h>

namespace Rydot
{

//eLg[
//bZ[W󂯎Xbh
//OpushŃbZ[Wǉ
//handleridleĎgB

template <class MessageType>
class messagethread:public thread
{
private:
	messagequeue<MessageType> msg;

private:
	int run()
	{
		while(isvalid())
		{
			MessageType m;
			if(msg.get(m))
			{
				handler(m);
			}
			else
			{
				idle();
			}
		}
		return 0;
	}

public:	
	//ŃbZ[Wǉ
	void push(const MessageType &m)
	{
		msg.push(m);
	}

protected:
	//ĂƁB
	virtual void handler(const MessageType &m)
	{
		return;
	}

	//ȂɂbZ[WȂƂ͂ˁB
	virtual void idle()
	{
		sleep(1);//eLg[
		return;
	}
};

};//end of namespace Rydot

#endif

